## imx-lib 5.1.0sendai3

=== Makefile ===
# Get all dirs with a Makefile
TMP_DIRS := $(foreach dir, $(wildcard *), $(wildcard $(dir)/Makefile))
DIRS := $(patsubst %/Makefile,%,$(TMP_DIRS))

.PHONY: all install clean
.PHONY: $(DIRS)
all: TARGET=all
all: $(DIRS)

install: TARGET=install
install: $(DIRS)

clean: TARGET=clean
clean : $(DIRS)

$(DIRS):
	$(MAKE) -C $@ $(TARGET)

=== ipu/Makefile ===
CC=$(CROSS_COMPILE)gcc
AR=$(CROSS_COMPILE)ar

OBJS = mxc_ipu_hl_lib.o mxc_ipu_lib.o

LIBNAME=libipu

all: $(LIBNAME).so

install:
	@mkdir -p $(DEST_DIR)/usr/lib
	cp $(LIBNAME).* $(DEST_DIR)/usr/lib
	@mkdir -p $(DEST_DIR)/usr/include
	cp mxc_ipu_hl_lib.h $(DEST_DIR)/usr/include

$(LIBNAME).so: $(OBJS)
	$(CC) -shared -nostartfiles -Wl,-soname,$@ -o $@ $^ -lpthread

%.o: %.c
ifeq "$(PLATFORM)" ""
	$(error "Unspecified PLATFORM variable")
endif
	$(CC) -D$(PLATFORM) $(INCLUDE) -Wall -O2 -c $^ -o $@

.PHONY: clean
clean:
	@rm -f $(OBJS) $(LIBNAME).*

=== rng/Makefile ===
AR = ar -crv
RM = rm -f
CC=$(CROSS_COMPILE)gcc
LD=$(CROSS_COMPILE)ld

INC := $(INCLUDE)

# Add compilation checks
CFLAGS += -g -Wall -W -Wmissing-prototypes -Wstrict-prototypes -Wdeclaration-after-statement

# In absence of kernel CONFIG flags, set API library to build on
# 'unknown' platform.
CFLAGS += -DFSL_PLATFORM_OTHER -DFSL_HAVE_RNGC $(INC)

OBJS= fsl_shw_rand.o  fsl_shw_hash.o  fsl_shw_sym.o  fsl_shw_user.o         \
		fsl_shw_keystore.o fsl_shw_auth.o  fsl_shw_hmac.o  fsl_shw_wrap.o

LIBNAME=libfsl_shw

all: $(LIBNAME).so $(LIBNAME).a

install: install_headers
	@mkdir -p $(DEST_DIR)/usr/lib
	cp $(LIBNAME).* $(DEST_DIR)/usr/lib

install_headers:
	@mkdir -p $(DEST_DIR)/usr/include

$(LIBNAME).a: $(OBJS)
	$(AR) $@ $^

$(LIBNAME).so: $(OBJS)
	$(CC) -shared -nostartfiles -Wl,-soname,$@ -o $@ $^

.PHONY: clean
clean:
	@rm -f *.o $(LIBNAME).*

# The keystore file is located in the Sahara directory
fsl_shw_keystore.o: ../sahara2/fsl_shw_keystore.c
	$(CC) $(CFLAGS) -c ../sahara2/fsl_shw_keystore.c

=== sahara2/Makefile ===
AR = ar -crv
RM = rm -f
CC=$(CROSS_COMPILE)gcc
LD=$(CROSS_COMPILE)ld

INC := $(INCLUDE)

DIAGS=

ifeq ("$(PLATFORM)", "IMX27ADS")
TARGET_ARCH=-DCONFIG_ARCH_MX27
endif
ifeq ("$(PLATFORM)", "IMX51")
TARGET_ARCH=-DCONFIG_ARCH_MX51
endif

# Add compilation checks
CFLAGS += -g -Wall -W -Wmissing-prototypes -Wstrict-prototypes -Wdeclaration-after-statement

OBJS= fsl_shw_rand.o  fsl_shw_hash.o  fsl_shw_sym.o  fsl_shw_user.o         \
      fsl_shw_auth.o  fsl_shw_hmac.o  fsl_shw_wrap.o  fsl_shw_keystore.o um_adaptor.o  sf_util.o


#CFLAGS += -DSAHARA -DLINUX -I$(APIINCDIR)
CFLAGS += -DSAHARA -DLINUX $(INC)
CFLAGS += $(TARGET_ARCH)
# Uncomment to debug Library's creation of structures for driver
#CFLAGS +=  -DDIAG_SECURITY_FUNC
# Uncomment to simulate memory allocation errors
#CFLAGS += -DDIAG_MEM_ERRORS -DDIAG_MEM_CONST=5

LIBNAME=libsahara

ifeq ("$(TARGET_ARCH)", "")
all install:
else
all: $(LIBNAME).so $(LIBNAME).a

install: install_headers
	@mkdir -p $(DEST_DIR)/usr/lib
	cp $(LIBNAME).* $(DEST_DIR)/usr/lib

install_headers:
	@mkdir -p $(DEST_DIR)/usr/include
endif


$(LIBNAME).a: $(OBJS)
	$(AR) $@ $^

$(LIBNAME).so: $(OBJS)
	$(CC) -shared -nostartfiles -Wl,-soname,$@ -o $@ $^

.PHONY: clean
clean:
	@rm -f $(OBJS) $(LIBNAME).*

fsl_shw_rand.o: fsl_shw_rand.c $(API_INCL)

fsl_shw_hash.o: fsl_shw_hash.c $(API_INCL)

fsl_shw_sym.o: fsl_shw_sym.c $(API_INCL)

fsl_shw_user.o: fsl_shw_user.c $(API_INCL)

fsl_shw_hmac.o: fsl_shw_hmac.c $(API_INCL)

fsl_shw_auth.o: fsl_shw_auth.c $(API_INCL)

fsl_shw_wrap.o: fsl_shw_wrap.c

fsl_shw_keystore.o: fsl_shw_keystore.c
um_adaptor.o: um_adaptor.c

sf_util.o: sf_util.c

=== screenlayer/Makefile ===
CC=$(CROSS_COMPILE)gcc
AR=$(CROSS_COMPILE)ar
INC = $(INCLUDE) -I../ipu

OBJS = ScreenLayer.o

LIBNAME=libIpuScreenLayer

all: $(LIBNAME).so

install:
	@mkdir -p $(DEST_DIR)/usr/lib
	cp $(LIBNAME).* $(DEST_DIR)/usr/lib
	@mkdir -p $(DEST_DIR)/usr/include
	cp ScreenLayer.h $(DEST_DIR)/usr/include

$(LIBNAME).so: $(OBJS)
	$(CC) -shared -nostartfiles -Wl,-soname,$@ -o $@ $^ -L../ipu -lipu

%.o: %.c
	$(CC) $(INC) -Wall -O2 -c $^ -o $@

.PHONY: clean
clean:
	@rm -f $(OBJS) $(LIBNAME).*

=== sim/Makefile ===
CC=$(CROSS_COMPILE)gcc
AR=$(CROSS_COMPILE)ar

OBJS = iso7816-3.o

CFLAGS += $(INCLUDE)

LIBNAME=libsim

# list of platforms which want this test case
INCLUDE_LIST:= IMX51 IMX25_3STACK

ifeq ($(PLATFORM), $(findstring $(PLATFORM), $(INCLUDE_LIST)))
all: $(LIBNAME).so

install:
	@mkdir -p $(DEST_DIR)/usr/lib
	cp $(LIBNAME).* $(DEST_DIR)/usr/lib
	@mkdir -p $(DEST_DIR)/usr/include
	cp iso7816-3.h $(DEST_DIR)/usr/include

$(LIBNAME).so: $(OBJS)
	$(CC) -shared -nostartfiles -Wl,-soname,$@ -o $@ $^ -lpthread

%.o: %.c
	$(CC) -D$(PLATFORM) $(INCLUDE) -Wall -O2 -c $^ -o $@

else
all install :
endif

.PHONY: clean
clean:
	@rm -f $(OBJS) $(LIBNAME).*

=== vpu/Makefile ===
CC=$(CROSS_COMPILE)gcc
AR=$(CROSS_COMPILE)ar

# list of platforms which want this test case
INCLUDE_LIST:= IMX27ADS IMX31ADS IMX32ADS IMX37_3STACK IMX51_3STACK IMX51

OBJ = vpu_io.o vpu_util.o vpu_lib.o

LIBNAME = libvpu
BINPREFIX = vpu_fw_

ifeq ($(PLATFORM), $(findstring $(PLATFORM), $(INCLUDE_LIST)))

# Same platform ID is used when building for imx31ads and imx32ads.
# Change version number in bin filename to imx32 if passed platform is
# imx31ads since there is no VPU module in imx31ads.
ifeq ($(PLATFORM), IMX31ADS)
PLATFORM_STR = IMX32ADS
else
PLATFORM_STR = $(PLATFORM)
endif

VERSION = $(shell echo $(PLATFORM_STR) | awk '{print substr($$0, 1, 5)}' \
	| awk '{print  tolower($$0) }' )

all: $(LIBNAME).so $(LIBNAME).a

install: install_headers
	@mkdir -p $(DEST_DIR)/usr/lib
	cp $(LIBNAME).* $(DEST_DIR)/usr/lib
	cp vpu_fw/$(BINPREFIX)$(VERSION)*.bin $(DEST_DIR)/usr/lib

install_headers:
	@mkdir -p $(DEST_DIR)/usr/include
	cp vpu_lib.h $(DEST_DIR)/usr/include
	cp vpu_io.h $(DEST_DIR)/usr/include
else
all install :
endif

%.o: %.c
	$(CC) -D$(PLATFORM) -Wall -O2 -c $^ -o $@

$(LIBNAME).so: $(OBJ)
	$(CC) -shared -nostartfiles -Wl,-soname,$@ $^ -o $@

$(LIBNAME).a: $(OBJ)
	$(AR) -rc $@  $^

.PHONY: clean
clean:
	rm -f $(LIBNAME).* $(OBJ)

=== debian/changelog ===
imx-lib (5.1.0sendai3) jaunty; urgency=low

  * Included some header file for the build request

 -- Jason Yen <jason.yen@canonical.com>  Tue, 30 Mar 2010 17:07:22 +0800

imx-lib (5.1.0sendai2) jaunty; urgency=low

  * Modify the debian/rules for the build dependency issue

 -- Jason Yen <jason.yen@canonical.com>  Mon, 29 Mar 2010 10:20:58 +0800

imx-lib (5.1.0sendai1) jaunty; urgency=low

  * Re-package freescale imx-lib 5.1.0 for sendai project

 -- Jason Yen <jason.yen@canonical.com>  Mon, 29 Mar 2010 09:44:18 +0800

=== debian/control ===
Source: imx-lib
Priority: extra
Maintainer: Herring Robert <ra7055@freescale.com>
Build-Depends: debhelper (>= 7), cdbs, linux-headers-sendai
Standards-Version: 3.8.0
Section: libs
Homepage: http://www.freescale.com

Package: imx-lib
Architecture: armel
Description: platform specific libraries for imx platform

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
CROSS= --build $(DEB_BUILD_GNU_TYPE)
endif


build: build-stamp

build-stamp:
	dh_testdir

	# Add here commands to compile the package.
	INCLUDE="$(INCLUDE) -I/usr/src/linux-headers-2.6.28-15-sendai/include" PLATFORM=IMX51 $(MAKE)
	#docbook-to-man debian/libgst-fsl-mm-plugins-vpu-v4l.sgml > libgst-fsl-mm-plugins-vpu-v4l.1

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) clean

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) DEST_DIR=$(CURDIR)/debian/imx-lib install


# Build architecture-independent files here.
binary-indep: install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
	dh_install
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	chmod 755 $(CURDIR)/debian/imx-lib/usr/lib/*.bin
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## imx-lib 11.03.00

=== ipu/Makefile ===
CC=$(CROSS_COMPILE)gcc
AR=$(CROSS_COMPILE)ar

OBJS = mxc_ipu_hl_lib.o mxc_ipu_lib.o

# list of platforms which want this test case
INCLUDE_LIST:= IMX37_3STACK IMX51 IMX53

LIBNAME=libipu

ifeq ($(PLATFORM), $(findstring $(PLATFORM), $(INCLUDE_LIST)))
all: $(LIBNAME).so

install:
	@mkdir -p $(DEST_DIR)/usr/lib
	cp $(LIBNAME).* $(DEST_DIR)/usr/lib
	@mkdir -p $(DEST_DIR)/usr/include
	cp mxc_ipu_hl_lib.h $(DEST_DIR)/usr/include
else
all install:
	@echo "Not support platform, will not complile"
endif

$(LIBNAME).so: $(OBJS)
	$(CC) -shared -nostartfiles -Wl,-soname,$@ -o $@ $^ -lpthread

%.o: %.c
ifeq "$(PLATFORM)" ""
	$(error "Unspecified PLATFORM variable")
endif
	$(CC) -D$(PLATFORM) $(INCLUDE) -Wall -O2 -fPIC -c $^ -o $@

.PHONY: clean
clean:
	@rm -f $(OBJS) $(LIBNAME).*

=== pxp/Makefile ===
CC=$(CROSS_COMPILE)gcc
AR=$(CROSS_COMPILE)ar

# list of platforms which want this test case
INCLUDE_LIST:=IMX50 IMX51 IMX5

OBJ = pxp_lib.o

LIBNAME = libpxp

ifeq ($(PLATFORM), $(findstring $(PLATFORM), $(INCLUDE_LIST)))

all: $(LIBNAME).so $(LIBNAME).a

install: install_headers
	@mkdir -p $(DEST_DIR)/usr/lib
	cp $(LIBNAME).* $(DEST_DIR)/usr/lib

install_headers:
	@mkdir -p $(DEST_DIR)/usr/include
	cp pxp_lib.h $(DEST_DIR)/usr/include
else
all install :
endif

%.o: %.c
	$(CC) -D$(PLATFORM) $(INCLUDE) -Wall -O2 -fPIC -c $^ -o $@

$(LIBNAME).so: $(OBJ)
	$(CC) -shared -nostartfiles -Wl,-soname,$@ $^ -o $@

$(LIBNAME).a: $(OBJ)
	$(AR) -rc $@  $^

.PHONY: clean
clean:
	rm -f $(LIBNAME).* $(OBJ)

=== rng/Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 INC := $(INCLUDE)
 
 # Add compilation checks
-CFLAGS += -g -Wall -W -Wmissing-prototypes -Wstrict-prototypes -Wdeclaration-after-statement
+CFLAGS += -g -Wall -W -Wmissing-prototypes -Wstrict-prototypes -Wdeclaration-after-statement -fPIC
 
 # In absence of kernel CONFIG flags, set API library to build on
 # 'unknown' platform.

=== sahara2/Makefile ===
--- 
+++ 
@@ -10,12 +10,12 @@
 ifeq ("$(PLATFORM)", "IMX27ADS")
 TARGET_ARCH=-DCONFIG_ARCH_MX27
 endif
-ifeq ("$(PLATFORM)", "IMX51")
-TARGET_ARCH=-DCONFIG_ARCH_MX51
+ifeq ($(findstring IMX5, $(PLATFORM)), IMX5)
+TARGET_ARCH=-DCONFIG_ARCH_MX5
 endif
 
 # Add compilation checks
-CFLAGS += -g -Wall -W -Wmissing-prototypes -Wstrict-prototypes -Wdeclaration-after-statement
+CFLAGS += -g -Wall -W -Wmissing-prototypes -Wstrict-prototypes -Wdeclaration-after-statement -fPIC
 
 OBJS= fsl_shw_rand.o  fsl_shw_hash.o  fsl_shw_sym.o  fsl_shw_user.o         \
       fsl_shw_auth.o  fsl_shw_hmac.o  fsl_shw_wrap.o  fsl_shw_keystore.o um_adaptor.o  sf_util.o

=== screenlayer/Makefile ===
--- 
+++ 
@@ -4,8 +4,12 @@
 
 OBJS = ScreenLayer.o
 
+# list of platforms which want this test case
+INCLUDE_LIST:= IMX37_3STACK IMX51 IMX53
+
 LIBNAME=libIpuScreenLayer
 
+ifeq ($(PLATFORM), $(findstring $(PLATFORM), $(INCLUDE_LIST)))
 all: $(LIBNAME).so
 
 install:
@@ -13,12 +17,16 @@
 	cp $(LIBNAME).* $(DEST_DIR)/usr/lib
 	@mkdir -p $(DEST_DIR)/usr/include
 	cp ScreenLayer.h $(DEST_DIR)/usr/include
+else
+all install:
+	@echo "Not support platform, will not complile"
+endif
 
 $(LIBNAME).so: $(OBJS)
 	$(CC) -shared -nostartfiles -Wl,-soname,$@ -o $@ $^ -L../ipu -lipu
 
 %.o: %.c
-	$(CC) $(INC) -Wall -O2 -c $^ -o $@
+	$(CC) $(INC) -Wall -O2 -fPIC -c $^ -o $@
 
 .PHONY: clean
 clean:

=== sim/Makefile ===
--- 
+++ 
@@ -23,7 +23,7 @@
 	$(CC) -shared -nostartfiles -Wl,-soname,$@ -o $@ $^ -lpthread
 
 %.o: %.c
-	$(CC) -D$(PLATFORM) $(INCLUDE) -Wall -O2 -c $^ -o $@
+	$(CC) -D$(PLATFORM) $(INCLUDE) -Wall -O2 -fPIC -c $^ -o $@
 
 else
 all install :

=== vpu/Makefile ===
--- 
+++ 
@@ -2,12 +2,11 @@
 AR=$(CROSS_COMPILE)ar
 
 # list of platforms which want this test case
-INCLUDE_LIST:= IMX27ADS IMX31ADS IMX32ADS IMX37_3STACK IMX51_3STACK IMX51
+INCLUDE_LIST:= IMX27ADS IMX31ADS IMX32ADS IMX37_3STACK IMX51 IMX53
 
 OBJ = vpu_io.o vpu_util.o vpu_lib.o
 
 LIBNAME = libvpu
-BINPREFIX = vpu_fw_
 
 ifeq ($(PLATFORM), $(findstring $(PLATFORM), $(INCLUDE_LIST)))
 
@@ -20,15 +19,18 @@
 PLATFORM_STR = $(PLATFORM)
 endif
 
+ifeq ($(findstring IMX5, $(PLATFORM)), IMX5)
+VERSION = imx5
+else
 VERSION = $(shell echo $(PLATFORM_STR) | awk '{print substr($$0, 1, 5)}' \
 	| awk '{print  tolower($$0) }' )
+endif
 
 all: $(LIBNAME).so $(LIBNAME).a
 
 install: install_headers
 	@mkdir -p $(DEST_DIR)/usr/lib
 	cp $(LIBNAME).* $(DEST_DIR)/usr/lib
-	cp vpu_fw/$(BINPREFIX)$(VERSION)*.bin $(DEST_DIR)/usr/lib
 
 install_headers:
 	@mkdir -p $(DEST_DIR)/usr/include
@@ -39,7 +41,7 @@
 endif
 
 %.o: %.c
-	$(CC) -D$(PLATFORM) -Wall -O2 -c $^ -o $@
+	$(CC) -D$(PLATFORM) -Wall -O2 -fPIC -c $^ -o $@
 
 $(LIBNAME).so: $(OBJ)
 	$(CC) -shared -nostartfiles -Wl,-soname,$@ $^ -o $@
